/*
 * generated by Xtext
 */
package fr.inria.phoenix.diasuite.diaswarm.generator

import com.google.inject.Inject
import com.google.inject.Provider
import fr.inria.phoenix.diasuite.diaswarm.DiaSwarmStandaloneSetup
import fr.inria.phoenix.diasuite.diaswarm.generator.DiaSwarmGenerator
import org.eclipse.emf.common.util.URI
import org.eclipse.emf.ecore.resource.ResourceSet
import org.eclipse.xtext.generator.JavaIoFileSystemAccess
import org.eclipse.xtext.util.CancelIndicator
import org.eclipse.xtext.validation.CheckMode
import org.eclipse.xtext.validation.IResourceValidator

class Main {

	def static main(String[] args) {
		println("Entering the main method !")
		if (args.empty) {
			System::err.println('Aborting: no path to EMF resource provided!')
			return
		}
		val injector = new DiaSwarmStandaloneSetup().createInjectorAndDoEMFRegistration
		val main = injector.getInstance(typeof(Main))
		main.runGenerator(args.get(0))
	}

	@Inject Provider<ResourceSet> resourceSetProvider

	@Inject IResourceValidator validator

	@Inject DiaSwarmGenerator generator

	@Inject JavaIoFileSystemAccess fileAccess

	def protected runGenerator(String string) {
		println("runGenerator : " + string)
		// load the resource
		val set = resourceSetProvider.get
		val resource = set.getResource(URI::createURI(string), true)

		// validate the resource
		val issues = validator.validate(resource, CheckMode::ALL, CancelIndicator::NullImpl)
		if (!issues.isEmpty()) {
			for (issue : issues) {
				System::err.println(issue)
			}
			return
		}

		// configure and start the generator
		fileAccess.setOutputPath('src-gen/')
//		generator.doGenerate(resource, fileAccess)
		generator.doGenerate(set, fileAccess)
		println('Code generation finished.')
	}
}
