package fr.inria.phoenix.diasuite.diaswarm.generator.template.datatype

import fr.inria.phoenix.diasuite.diaswarm.diaswarm.EnumDef
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.PrimitiveTypeRef
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.StructDef
import fr.inria.phoenix.diasuite.diaswarm.generator.template.DiaSwarmEntity

import static extension fr.inria.phoenix.diasuite.diaswarm.generator.template.datatype.DiaSwarmDatatypeHelper.*
import static extension fr.inria.phoenix.diasuite.diaswarm.generator.template.Utils.*
import fr.inria.phoenix.diasuite.diaswarm.services.DiaSwarmGrammarAccess.EnumDefElements

class DiaSwarmDatatype extends DiaSwarmEntity {

	def generateEnumeration(EnumDef enumDef) '''
		package «enumDef.packageName»;        
		
		public enum «enumDef.name.toFirstUpper» {
		    «enumDef.constants.join(", ")»
		}
	'''

//	def generateWritableEnumeration(EnumDef enumDef) '''
//		package «enumDef.packageName»;        
//		
//		public enum «enumDef.name.toFirstUpper» {
//		    «enumDef.constants.join(", ")»
//		}
//	'''

	/**
	 * Generates the java code for the structure provided by parameter. 
	 */
	def generateWritableStructure(StructDef structDef) '''
		package «structDef.packageName»;
		
		import java.io.DataInput;
		import java.io.DataOutput;
		import java.io.IOException;
		
		«FOR field : structDef.structFields»
		import «field.dataTypeRef.hadoopTypeName»;
		«ENDFOR»
		import org.apache.hadoop.io.WritableComparable;
		
		public class «structDef.name.toFirstUpper»Writable implements WritableComparable<«structDef.name.toFirstUpper»Writable> {
			
			«FOR field : structDef.structFields»
				private «field.dataTypeRef.hadoopTypeName» «field.name»Writable;
			«ENDFOR»
			«val constructorEmptyWritableParams = structDef.structFields.map["new " + dataTypeRef.getHadoopTypeName().split('\\.').last + "()" ].join(",\n")»
			«val constructorDefinedWritableParams = structDef.structFields.map["new " + dataTypeRef.getHadoopTypeName().split('\\.').last + "(" + name + ")" ].join(",\n")»
			«val constructorDefinedTypeParam = structDef.structFields.map["new " + dataTypeRef.getHadoopTypeName().split('\\.').last + "(" + structDef.name.toFirstLower + "." + "get" + name.toFirstUpper + "()" + ")" ].join(",\n")»
			«val constructorParams = structDef.structFields.map["final " + dataTypeRef.getTypeName().split('\\.').last + " " + name ].join(",\n")»
			«val sourceTypeParams = structDef.structFields.map[name].join(", ")»
			«val sourceFieldWritableTypes = structDef.structFields.map["final " + dataTypeRef.hadoopTypeName.split('\\.').last + " " + name].join(", ")»
			«val sourceFieldWritableTypesInstances = structDef.structFields.map["new " + dataTypeRef.hadoopTypeName.split('\\.').last + "()"].join(", ")»
			«val sourceFieldsWritabletoJavaConversion = structDef.structFields.map[if (dataTypeRef.type != null && dataTypeRef.type instanceof EnumDef) dataTypeRef.fullName + ".valueOf(" + name + "Writable.toString())" else if (dataTypeRef.hadoopTypeName.endsWith("Text")) name + "Writable.toString()" else name + "Writable.get()"].join(", ")»
«««			«FOR field : structDef.structFields»«IF field.dataTypeRef.hadoopTypeName.endsWith("Text")»«field.name».toString()«ELSE»«field.name».get()«ENDIF»«ENDFOR»
			«val constructorWritableParams = structDef.structFields.map[dataTypeRef.getHadoopTypeName().split('\\.').last + " " + name ].join(",\n")»
			«val writableFieldsToJava = structDef.structFields.map[if(dataTypeRef.getHadoopTypeName().split('\\.').last.equals("Text")) (name + ".toString()") else (name + ".get()") ].join(",\n")»
			
			public «structDef.name.toFirstUpper»Writable() {
				set(«sourceFieldWritableTypesInstances»);
			}
			
			public «structDef.name.toFirstUpper»Writable(«structDef.name» «structDef.name.toFirstLower») {
				set(«structDef.name.toFirstLower»);
			}
			
			public «structDef.name.toFirstUpper»Writable(«sourceFieldWritableTypes») {
				set(«sourceTypeParams»);
			}
		
			private void set(«sourceFieldWritableTypes») {
				«FOR field : structDef.structFields»
				this.«field.name»Writable = «field.name»;
				«ENDFOR»
			}
			
			private void set(final «structDef.name.toFirstUpper» «structDef.name.toFirstLower») {
				«FOR field : structDef.structFields»
				«IF field.dataTypeRef.type != null && field.dataTypeRef.type instanceof EnumDef»
				this.«field.name»Writable = new «field.dataTypeRef.getHadoopTypeName().split('\\.').last + "(" + structDef.name.toFirstLower + "." + "get" + field.name.toFirstUpper + "().toString()" + ")"»;
				«ELSE»
				this.«field.name»Writable = new «field.dataTypeRef.getHadoopTypeName().split('\\.').last + "(" + structDef.name.toFirstLower + "." + "get" + field.name.toFirstUpper + "()" + ")"»;
				«ENDIF»
				«ENDFOR»
			}
			
			public «structDef.name.toFirstUpper» get() {
				return new «structDef.name.toFirstUpper»(«sourceFieldsWritabletoJavaConversion»);
			}
		
			«FOR field : structDef.structFields»
			public «field.dataTypeRef.hadoopTypeName» get«field.name.toFirstUpper»() {
				return this.«field.name»Writable;
			}
			«ENDFOR»
			
			@Override
			public void write(DataOutput out) throws IOException {
				«FOR field : structDef.structFields»
				«field.name»Writable.write(out);
				«ENDFOR»
			}

			@Override
			public void readFields(DataInput in) throws IOException {
				«FOR field : structDef.structFields»
				«field.name»Writable.readFields(in);
				«ENDFOR»
			}
			
			@Override
			public int compareTo(«structDef.name.toFirstUpper»Writable «structDef.name.toFirstLower»Writable) {
				«FOR field : structDef.structFields»
				«field.dataTypeRef.getHadoopTypeName().split('\\.').last» «field.name»Value = «structDef.name.toFirstLower»Writable.«field.name»Writable;
				«ENDFOR»
				
				«FOR field : structDef.structFields»
				int «field.name»WritableCmp = this.«field.name»Writable.compareTo(«field.name»Value);
				if(«field.name»WritableCmp != 0)
					return «field.name»WritableCmp;
					
				«ENDFOR»
				return 0;
			}
			
«««			@Override
«««			public int hashCode() {
«««				return «FOR field : structDef.structFields»«field.name».hashCode() + «ENDFOR»
«««			}
		}
	'''

	/**
	 * Generates the java code for the structure provided by parameter. 
	 */
	def generateStructure(StructDef structDef) '''
		package «structDef.packageName»;
		
		import java.io.Serializable;        
		
		public class «structDef.name.toFirstUpper» implements Serializable {
		    
		    private static final long serialVersionUID = 0;
		    
		    public «structDef.name.toFirstUpper»() {
		    }
		
		    «IF ! structDef.structFields.isEmpty()»
			public «structDef.name.toFirstUpper»(«structDef.structFields.map[dataTypeRef.fullName + " " + name.toFirstLower].join(",\n        ")») {
			    «FOR field: structDef.structFields»
			    	this.«field.name.toFirstLower» = «field.name.toFirstLower»;
			    «ENDFOR»
			}
		    «ENDIF»
		    «FOR field : structDef.structFields»
			
			/********** Generated code for field «field.name» **********/
			
			private «field.dataTypeRef.fullName» «field.name.toFirstLower»;
			
			public «field.dataTypeRef.fullName» get«field.name.toFirstUpper»() {
				return «field.name.toFirstLower»;
			}
			
			public void set«field.name.toFirstUpper»(«field.dataTypeRef.fullName» «field.name.toFirstLower») {
				this.«field.name.toFirstLower» = «field.name.toFirstLower»;
			}
			
			/**************************************************/
			
			«ENDFOR» 
			«equalsAndHashCode(structDef.name, structDef.structFields.map[name])»
		
		   @Override
		   public String toString() {
		       return "«structDef.name» [" + 
		           «FOR field : structDef.structFields SEPARATOR "\", \" + "»
		           	«IF field.dataTypeRef.primitiveTypeRef.equals(PrimitiveTypeRef.BINARY)»
		           		"«field.name.toFirstLower».length=" + «field.name.toFirstLower».length +
		           	«ELSE»
		           		"«field.name.toFirstLower»=" + «field.name.toFirstLower» +
		           	«ENDIF»
		           «ENDFOR»
		       "]";
		   }
		   
		   public String toJSON() {
		       return "{" + 
		   		   «FOR field : structDef.structFields SEPARATOR "\", \" + "»
		   		   		"\"«field.name.toFirstLower»\": " + "\"" + «field.name.toFirstLower» + "\"" +
		   		   «ENDFOR»
		   		   "}";
		   	   }
		}
	'''

}
