package fr.inria.phoenix.diasuite.diaswarm.generator.template.mock

import fr.inria.phoenix.diasuite.diaswarm.diaswarm.DeviceType
import fr.inria.phoenix.diasuite.diaswarm.generator.template.IConstant

class DiaSwarmMockHelper {

	/**============================ HELPER METHODS ==============================**/
	/**
	 * Returns a string representing the filename of an device java class 
	 * along with it's namespace.
	 */
	def static generateMockDeviceFileName(DeviceType device) {
		device.mockPackageName.replaceAll("\\.", "/") + "/" + device.name + "Mock" + ".java"
	}

	def static generateMockFileName() {
		mockPackageName.replaceAll("\\.", "/") + "/" + "Mock" + ".java"
	}

	/**
	 * Returns a string representing the package namespace for devices.  
	 */
	def static getMockPackageName(DeviceType device) {
		IConstant.BASE_PACKAGE_NAMESPACE + "." + IConstant.MOCK_PACKAGE_NAME
	}

	/**
	 * Returns a string representing the package namespace for devices.  
	 */
	def static getMockPackageName() {
		IConstant.BASE_PACKAGE_NAMESPACE + "." + IConstant.MOCK_PACKAGE_NAME
	}

}
