/*
 * generated by Xtext
 */
package fr.inria.phoenix.diasuite.diaswarm.ui.labeling

import com.google.inject.Inject
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.ActionDef
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.ActionRef
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.ActionImpl
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.AttributeDef
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.ContextDef
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.ControllerDef
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.DeviceType
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.DomainModel
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.EnumDef
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.IncludeSpec
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.InteractionContractDef
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.OrderDef
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.SourceDef
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.SourceRef
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.StructDef
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.StructFieldDef
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.VariableDef
import fr.inria.phoenix.diasuite.diaswarm.generator.template.Utils

import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider
import org.eclipse.xtext.ui.label.DefaultEObjectLabelProvider

/**
 * Provides labels for EObjects.
 * 
 * See https://www.eclipse.org/Xtext/documentation/304_ide_concepts.html#label-provider
 */
class DiaSwarmLabelProvider extends DefaultEObjectLabelProvider {

	@Inject
	new(AdapterFactoryLabelProvider delegate) {
		super(delegate);
	}

// Labels and icons can be computed like this:
//	def text(Greeting ele) {
//		'A greeting to ' + ele.name
//	}
//
//	def image(Greeting ele) {
//		'Greeting.gif'
//	}
	def String text(DomainModel document) {
		return "Specification";
	}

	def String text(IncludeSpec include_spec_elt) {
		return include_spec_elt.getImportURI();
	}

	def String text(ControllerDef controller) {
		return controller.getName();
	}

	def String text(ContextDef context) {
		var String dataType = Utils.extractDatatypeName(context.getDataTypeRef());
		return context.getName() + " as " + dataType;
	}

	def String text(ActionImpl action) {
		return action.getAction().getName();
	}

	def String text(DeviceType deviceDef) {
		var StringBuffer result = new StringBuffer(deviceDef.getName());
		if (deviceDef.getSuperDevice() != null) {
			result.append(" extends ");
//            for (DeviceType superDevice : deviceDef.getSuperDevices()) {
			result.append(deviceDef.getSuperDevice().getName()).append(", ");
//            }
			result.delete(result.length() - 2, result.length());
		}
		return result.toString();
	}

	def String text(AttributeDef attributeDef) {
		var String dataType = Utils.extractDatatypeName(attributeDef.getAttrTypeRef());
		return attributeDef.getName() + " as " + dataType;
	}

	def String text(SourceDef sourceDef) {
		var String dataType = Utils.extractDatatypeName(sourceDef.getDataTypeRef());
		return sourceDef.getName() + " as " + dataType;
	}

	def String text(StructFieldDef field) {
		var String dataType = Utils.extractDatatypeName(field.getDataTypeRef());
		return field.getName() + " as " + dataType;
	}

	def String text(OrderDef order) {
		var String o = order.getName() + "(";
		for (VariableDef p : order.getParams()) {
			var String dataType = Utils.extractDatatypeName(p.getDataTypeRef());
			if (!o.endsWith("(")) {
				o += ", ";
			}
			o += p.getName() + " as " + dataType;
		}
		return o + ")";
	}

	def String text(VariableDef varr) {
		return varr.getName() + " as " + Utils.extractDatatypeName(varr.getDataTypeRef());
	}

	def String text(SourceRef sourceRef) {
		var String ref = "";
		if (sourceRef.getSource() != null) {
			ref = sourceRef.getSource().getName();
		}
		return ref + " from " + sourceRef.getDevice().getName();
	}

	def String text(ActionRef actionRef) {
		return actionRef.getAction().getName() + " on " + actionRef.getDevice().getName();
	}

	def String image(DomainModel document) {
		return "DocumentIcon.png";
	}

	def String image(DeviceType deviceDef) {
		return "DeviceIcon.png";
	}

	def String image(ControllerDef controller) {
		return "ControllerIcon.png";
	}

	def String image(ContextDef context) {
		return "ContextIcon.png";
	}

	def String image(ActionImpl action) {
		return "ActionIcon.png";
	}

	def String image(SourceDef source) {
		return "SourceIcon.png";
	}

	def String image(SourceRef source) {
		return "SourceIcon.png";
	}

	def String image(ActionDef action) {
		return "ActionDefIcon.png";
	}

	def String image(ActionRef action) {
		return "ActionIcon.png";
	}

	def String image(StructFieldDef structField) {
		return "StructFieldIcon.png";
	}

	def String image(OrderDef order) {
		return "OrderIcon.png";
	}

	def String image(StructDef elt) {
		return "StructIcon.png";
	}

	def String image(EnumDef elt) {
		return "EnumIcon.png";
	}

	def String image(AttributeDef attribute) {
		return "AttributeIcon.png";
	}

	def String image(IncludeSpec elt) {
		return "IncludeSpecIcon.png";
	}

	/* Behaviors */
	def String text(InteractionContractDef contextBehaviorDef) {
		return "interaction";
	}
}
