/**
 * generated by Xtext
 */
package fr.inria.phoenix.diasuite.diaswarm.ui.labeling;

import com.google.common.base.Objects;
import com.google.inject.Inject;
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.ActionDef;
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.ActionImpl;
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.ActionRef;
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.AttributeDef;
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.ContextDef;
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.ControllerDef;
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.DataTypeRef;
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.DeviceType;
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.DomainModel;
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.EnumDef;
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.IncludeSpec;
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.InteractionContractDef;
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.OrderDef;
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.SourceDef;
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.SourceRef;
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.StructDef;
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.StructFieldDef;
import fr.inria.phoenix.diasuite.diaswarm.diaswarm.VariableDef;
import fr.inria.phoenix.diasuite.diaswarm.generator.template.Utils;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.xtext.ui.label.DefaultEObjectLabelProvider;

/**
 * Provides labels for EObjects.
 * 
 * See https://www.eclipse.org/Xtext/documentation/304_ide_concepts.html#label-provider
 */
@SuppressWarnings("all")
public class DiaSwarmLabelProvider extends DefaultEObjectLabelProvider {
  @Inject
  public DiaSwarmLabelProvider(final AdapterFactoryLabelProvider delegate) {
    super(delegate);
  }
  
  public String text(final DomainModel document) {
    return "Specification";
  }
  
  public String text(final IncludeSpec include_spec_elt) {
    return include_spec_elt.getImportURI();
  }
  
  public String text(final ControllerDef controller) {
    return controller.getName();
  }
  
  public String text(final ContextDef context) {
    DataTypeRef _dataTypeRef = context.getDataTypeRef();
    String dataType = Utils.extractDatatypeName(_dataTypeRef);
    String _name = context.getName();
    String _plus = (_name + " as ");
    return (_plus + dataType);
  }
  
  public String text(final ActionImpl action) {
    ActionDef _action = action.getAction();
    return _action.getName();
  }
  
  public String text(final DeviceType deviceDef) {
    String _name = deviceDef.getName();
    StringBuffer result = new StringBuffer(_name);
    DeviceType _superDevice = deviceDef.getSuperDevice();
    boolean _notEquals = (!Objects.equal(_superDevice, null));
    if (_notEquals) {
      result.append(" extends ");
      DeviceType _superDevice_1 = deviceDef.getSuperDevice();
      String _name_1 = _superDevice_1.getName();
      StringBuffer _append = result.append(_name_1);
      _append.append(", ");
      int _length = result.length();
      int _minus = (_length - 2);
      int _length_1 = result.length();
      result.delete(_minus, _length_1);
    }
    return result.toString();
  }
  
  public String text(final AttributeDef attributeDef) {
    DataTypeRef _attrTypeRef = attributeDef.getAttrTypeRef();
    String dataType = Utils.extractDatatypeName(_attrTypeRef);
    String _name = attributeDef.getName();
    String _plus = (_name + " as ");
    return (_plus + dataType);
  }
  
  public String text(final SourceDef sourceDef) {
    DataTypeRef _dataTypeRef = sourceDef.getDataTypeRef();
    String dataType = Utils.extractDatatypeName(_dataTypeRef);
    String _name = sourceDef.getName();
    String _plus = (_name + " as ");
    return (_plus + dataType);
  }
  
  public String text(final StructFieldDef field) {
    DataTypeRef _dataTypeRef = field.getDataTypeRef();
    String dataType = Utils.extractDatatypeName(_dataTypeRef);
    String _name = field.getName();
    String _plus = (_name + " as ");
    return (_plus + dataType);
  }
  
  public String text(final OrderDef order) {
    String _name = order.getName();
    String o = (_name + "(");
    EList<VariableDef> _params = order.getParams();
    for (final VariableDef p : _params) {
      {
        DataTypeRef _dataTypeRef = p.getDataTypeRef();
        String dataType = Utils.extractDatatypeName(_dataTypeRef);
        boolean _endsWith = o.endsWith("(");
        boolean _not = (!_endsWith);
        if (_not) {
          String _o = o;
          o = (_o + ", ");
        }
        String _o_1 = o;
        String _name_1 = p.getName();
        String _plus = (_name_1 + " as ");
        String _plus_1 = (_plus + dataType);
        o = (_o_1 + _plus_1);
      }
    }
    return (o + ")");
  }
  
  public String text(final VariableDef varr) {
    String _name = varr.getName();
    String _plus = (_name + " as ");
    DataTypeRef _dataTypeRef = varr.getDataTypeRef();
    String _extractDatatypeName = Utils.extractDatatypeName(_dataTypeRef);
    return (_plus + _extractDatatypeName);
  }
  
  public String text(final SourceRef sourceRef) {
    String ref = "";
    SourceDef _source = sourceRef.getSource();
    boolean _notEquals = (!Objects.equal(_source, null));
    if (_notEquals) {
      SourceDef _source_1 = sourceRef.getSource();
      String _name = _source_1.getName();
      ref = _name;
    }
    DeviceType _device = sourceRef.getDevice();
    String _name_1 = _device.getName();
    return ((ref + " from ") + _name_1);
  }
  
  public String text(final ActionRef actionRef) {
    ActionDef _action = actionRef.getAction();
    String _name = _action.getName();
    String _plus = (_name + " on ");
    DeviceType _device = actionRef.getDevice();
    String _name_1 = _device.getName();
    return (_plus + _name_1);
  }
  
  public String image(final DomainModel document) {
    return "DocumentIcon.png";
  }
  
  public String image(final DeviceType deviceDef) {
    return "DeviceIcon.png";
  }
  
  public String image(final ControllerDef controller) {
    return "ControllerIcon.png";
  }
  
  public String image(final ContextDef context) {
    return "ContextIcon.png";
  }
  
  public String image(final ActionImpl action) {
    return "ActionIcon.png";
  }
  
  public String image(final SourceDef source) {
    return "SourceIcon.png";
  }
  
  public String image(final SourceRef source) {
    return "SourceIcon.png";
  }
  
  public String image(final ActionDef action) {
    return "ActionDefIcon.png";
  }
  
  public String image(final ActionRef action) {
    return "ActionIcon.png";
  }
  
  public String image(final StructFieldDef structField) {
    return "StructFieldIcon.png";
  }
  
  public String image(final OrderDef order) {
    return "OrderIcon.png";
  }
  
  public String image(final StructDef elt) {
    return "StructIcon.png";
  }
  
  public String image(final EnumDef elt) {
    return "EnumIcon.png";
  }
  
  public String image(final AttributeDef attribute) {
    return "AttributeIcon.png";
  }
  
  public String image(final IncludeSpec elt) {
    return "IncludeSpecIcon.png";
  }
  
  /**
   * Behaviors
   */
  public String text(final InteractionContractDef contextBehaviorDef) {
    return "interaction";
  }
}
